package FogProtect.knowledgeBaseAsIsModel.rest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

import com.google.gson.JsonObject;

import FogProtect.knowledgeBaseAsIsModel.cdo.CdoClient;
import FogProtect.knowledgeBaseAsIsModel.kafka.ProducerClient;
import FogProtect.knowledgeBaseAsIsModel.utils.ModelLoader;
import FogProtect.knowledgeBaseAsIsModel.utils.Modeltype;
import FogProtect.knowledgeBaseAsIsModel.utils.PersonalLogger;
import fogprotect.adaptation.ComputingContinuumModel.CloudEnvironment;

@RestController
public class MyRestController {

	@Autowired
	private MyService myService;

	@Autowired
	private ProducerClient producerClient;
	
	@Autowired
	private CdoClient cdoClient;
	
	@Autowired
	private ModelLoader loader;
	
	@Autowired
	private MonitoringController monitoringController;
	
	@Autowired
	PersonalLogger log;
	
	private static String className = MyRestController.class.getName();

	// todo request handling

	// some endpoints

	@RequestMapping(path = "/fogprotect/knowledgebaseasismodel/statusInformation", method = RequestMethod.GET, consumes = "*/*; charset=UTF-8")
	@ResponseBody
	public String statusInformation() {
		return myService.createStatusInformationJson();
	}

	@RequestMapping(path = "/fogprotect/knowledgebaseasismodel/mostRecentAsIsModel", method = RequestMethod.GET, consumes = "*/*; charset=UTF-8")
	@ResponseBody
	public String mostRecentAsIsModel() {
		return loader.modelToJsonString((CloudEnvironment) cdoClient.retrieveMostRecentModel(Modeltype.AS_IS_MODEL));
	}

	@RequestMapping(path = "/fogprotect/knowledgebaseasismodel/secondMostRecentAsIsModel", method = RequestMethod.GET, consumes = "*/*; charset=UTF-8")
	@ResponseBody
	public String secondMostRecentAsIsModel() {
		CloudEnvironment ce = (CloudEnvironment) cdoClient.retrieveSecondRecentModel(Modeltype.AS_IS_MODEL);
		if (ce == null) {
			log.info("Warning: SecondRecentModel was not found. Returning most recent model", className);
			ce = (CloudEnvironment) cdoClient.retrieveMostRecentModel(Modeltype.AS_IS_MODEL);
		}
		return loader.modelToJsonString(ce);
	}

	// ---------------------TESTING-------------------------

	@GetMapping(path = "kafka/testWrite")
	public ResponseEntity<String> writeTestMsg() {

		return myService.writeStringToTopic("asadssdaadsads", "testMessage123");
	}

	@GetMapping(path = "kafka/createTopic")
	public ResponseEntity<String> createTopic(@RequestParam(value = "name", defaultValue = "") String topicName) {
		return myService.createTopic(topicName);
	}

	/**
	 * deleted topic are not deleted immediately but only marked for deletion
	 */
	@GetMapping(path = "kafka/deleteTopic")
	public ResponseEntity<String> deleteTopic(@RequestParam(value = "name", defaultValue = "") String topicName) {
		return myService.deleteTopic(topicName);
	}

	@GetMapping(path = "kafka/cdotest")
	public ResponseEntity<String> testCdo() {
		return myService.testCdo1();
	}

	@GetMapping(path = "sendStatusInformationToModelChange4SIEA1")
	public ResponseEntity<String> sendStatusInformationToModelChange4SIEA1() {
		// OpenDoor => Trustworthy changes to LOW
		String jsonString = "{\"AsIs\":{\"AsIsModel\":{\"type\":\"CloudEnvironment\",\"@id\":\"/\",\"tosca_nodes_root\":[{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.0\",\"name\":\"NUC 1 (Botcraft VM and IDS VM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.1\",\"name\":\"Dashboard Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"controlledBy\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"}]},{\"type\":\"Database\",\"@id\":\"//@tosca_nodes_root.2\",\"name\":\"Database\",\"id\":0,\"hostedOn\":{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},\"stores\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"}],\"encrypted\":false},{\"type\":\"DBMS\",\"@id\":\"//@tosca_nodes_root.3\",\"name\":\"IDS Data Lake\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"hosts\":[{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}]},{\"type\":\"DataSubject\",\"@id\":\"//@tosca_nodes_root.4\",\"name\":\"Person\",\"id\":0,\"trust\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"location\":\"DE\",\"owns\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.5\",\"name\":\"Robot MES\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.6\",\"name\":\"Kafka Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.7\",\"name\":\"Scene Detection\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.8\",\"name\":\"Data Flow (Scene Detection - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"connectionType\":\"Local\"},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.9\",\"name\":\"ABB Robot\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.10\",\"name\":\"IP Camera\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"StoredDataSet\",\"@id\":\"//@tosca_nodes_root.11\",\"name\":\"Stored Data Set\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"storedIn\":{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.12\",\"name\":\"Scene Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.13\",\"name\":\"NUC 2 (FogProtectVM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.14\",\"name\":\"Google ML Board-1\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.15\",\"name\":\"Robot Monitor Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.16\",\"name\":\"Data Flow (Dashboard Server - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.17\",\"name\":\"Data Flow (Robot MES - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.18\",\"name\":\"Robot Control\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.19\",\"name\":\"Data Flow (Robot Control - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.24\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.20\",\"name\":\"Data Flow (Robot Monitor - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.27\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.21\",\"name\":\"Data Flow (Camera Streamer - Scene Detection)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.22\",\"name\":\"Camera Streamer\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.23\",\"name\":\"Camera Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.24\",\"name\":\"Robot Control Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.25\",\"name\":\"Robot Monitor\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.26\",\"name\":\"Order\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.27\",\"name\":\"Robot Monitor Data Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.28\",\"name\":\"Data Flow (Dashboard Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.29\",\"name\":\"Data Flow (Kafka Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.30\",\"name\":\"Security Flag\",\"id\":0,\"partOf\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"PrivateSpace\",\"@id\":\"//@tosca_nodes_root.31\",\"name\":\"FiaB Shipping Container\",\"id\":0,\"consistsOf\":[{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"}],\"trustworthy\":\"LOW\"},{\"type\":\"DataController\",\"@id\":\"//@tosca_nodes_root.32\",\"name\":\"FiaB Worker\",\"id\":0,\"location\":\"DE\",\"controls\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"}]}]},\"OldAsIsModel\":{\"type\":\"CloudEnvironment\",\"@id\":\"/\",\"tosca_nodes_root\":[{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.0\",\"name\":\"NUC 1 (Botcraft VM and IDS VM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.1\",\"name\":\"Dashboard Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"controlledBy\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"}]},{\"type\":\"Database\",\"@id\":\"//@tosca_nodes_root.2\",\"name\":\"Database\",\"id\":0,\"hostedOn\":{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},\"stores\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"}],\"encrypted\":false},{\"type\":\"DBMS\",\"@id\":\"//@tosca_nodes_root.3\",\"name\":\"IDS Data Lake\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"hosts\":[{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}]},{\"type\":\"DataSubject\",\"@id\":\"//@tosca_nodes_root.4\",\"name\":\"Person\",\"id\":0,\"trust\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"location\":\"DE\",\"owns\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.5\",\"name\":\"Robot MES\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.6\",\"name\":\"Kafka Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.7\",\"name\":\"Scene Detection\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.8\",\"name\":\"Data Flow (Scene Detection - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"connectionType\":\"Local\"},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.9\",\"name\":\"ABB Robot\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.10\",\"name\":\"IP Camera\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"StoredDataSet\",\"@id\":\"//@tosca_nodes_root.11\",\"name\":\"Stored Data Set\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"storedIn\":{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.12\",\"name\":\"Scene Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.13\",\"name\":\"NUC 2 (FogProtectVM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.14\",\"name\":\"Google ML Board-1\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.15\",\"name\":\"Robot Monitor Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.16\",\"name\":\"Data Flow (Dashboard Server - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.17\",\"name\":\"Data Flow (Robot MES - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.18\",\"name\":\"Robot Control\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.19\",\"name\":\"Data Flow (Robot Control - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.24\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.20\",\"name\":\"Data Flow (Robot Monitor - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.27\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.21\",\"name\":\"Data Flow (Camera Streamer - Scene Detection)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.22\",\"name\":\"Camera Streamer\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.23\",\"name\":\"Camera Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.24\",\"name\":\"Robot Control Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.25\",\"name\":\"Robot Monitor\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.26\",\"name\":\"Order\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.27\",\"name\":\"Robot Monitor Data Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.28\",\"name\":\"Data Flow (Dashboard Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.29\",\"name\":\"Data Flow (Kafka Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.30\",\"name\":\"Security Flag\",\"id\":0,\"partOf\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"PrivateSpace\",\"@id\":\"//@tosca_nodes_root.31\",\"name\":\"FiaB Shipping Container\",\"id\":0,\"consistsOf\":[{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"}],\"trustworthy\":\"HIGH\"},{\"type\":\"DataController\",\"@id\":\"//@tosca_nodes_root.32\",\"name\":\"FiaB Worker\",\"id\":0,\"location\":\"DE\",\"controls\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"}]}]},\"ChangesMadeToAsIsModel\":[{\"ObjectToIdentify\":{\"name\":\"FiaB Shipping Container\",\"type\":\"fogprotect.adaptation.ComputingContinuumModel.PrivateSpace\",\"atid\":\"//@tosca_nodes_root.31\"},\"Changes\":[{\"ChangeType\":\"CHANGE\",\"AttributeChanged\":\"trustworthy\",\"AttributeType\":\"Trustworthy\",\"AttributeOldValue\":\"HIGH\",\"AttributeNewValue\":\"LOW\"}]}],\"Risks\":[]},\"Adaptations\":[]}";
		producerClient.sendMessage("ModelChange4SIEA", jsonString);
		return new ResponseEntity<String>("Done", HttpStatus.OK);
	}

	@GetMapping(path = "sendStatusInformationToModelChange4SIEA2")
	public ResponseEntity<String> sendStatusInformationToModelChange4SIEA2() {
		// DataFlowsDisabled
		String jsonString = "{\"AsIs\":{\"AsIsModel\":{\"type\":\"CloudEnvironment\",\"@id\":\"//\",\"tosca_nodes_root\":[{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.0\",\"name\":\"NUC 1 (Botcraft VM and IDS VM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.1\",\"name\":\"Dashboard Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"controlledBy\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"}]},{\"type\":\"Database\",\"@id\":\"//@tosca_nodes_root.2\",\"name\":\"Database\",\"id\":0,\"hostedOn\":{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},\"stores\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"}],\"encrypted\":false},{\"type\":\"DBMS\",\"@id\":\"//@tosca_nodes_root.3\",\"name\":\"IDS Data Lake\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"hosts\":[{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}]},{\"type\":\"DataSubject\",\"@id\":\"//@tosca_nodes_root.4\",\"name\":\"Person\",\"id\":0,\"trust\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"location\":\"DE\",\"owns\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.5\",\"name\":\"Robot MES\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.6\",\"name\":\"Kafka Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.7\",\"name\":\"Scene Detection\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.8\",\"name\":\"Data Flow (Scene Detection - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"connectionType\":\"Local\"},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.9\",\"name\":\"ABB Robot\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.10\",\"name\":\"IP Camera\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"StoredDataSet\",\"@id\":\"//@tosca_nodes_root.11\",\"name\":\"Stored Data Set\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"storedIn\":{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.12\",\"name\":\"Scene Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.13\",\"name\":\"NUC 2 (FogProtectVM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.14\",\"name\":\"Google ML Board-1\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.15\",\"name\":\"Robot Monitor Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.16\",\"name\":\"Data Flow (Dashboard Server - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":true,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.17\",\"name\":\"Data Flow (Robot MES - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.18\",\"name\":\"Robot Control\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.19\",\"name\":\"Data Flow (Robot Control - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.24\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.20\",\"name\":\"Data Flow (Robot Monitor - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.27\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.21\",\"name\":\"Data Flow (Camera Streamer - Scene Detection)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.22\",\"name\":\"Camera Streamer\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.23\",\"name\":\"Camera Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.24\",\"name\":\"Robot Control Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.25\",\"name\":\"Robot Monitor\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.26\",\"name\":\"Order\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.27\",\"name\":\"Robot Monitor Data Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.28\",\"name\":\"Data Flow (Dashboard Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":true,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.29\",\"name\":\"Data Flow (Kafka Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.30\",\"name\":\"Security Flag\",\"id\":0,\"partOf\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"PrivateSpace\",\"@id\":\"//@tosca_nodes_root.31\",\"name\":\"FiaB Shipping Container\",\"id\":0,\"consistsOf\":[{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"}],\"trustworthy\":\"LOW\"},{\"type\":\"DataController\",\"@id\":\"//@tosca_nodes_root.32\",\"name\":\"FiaB Worker\",\"id\":0,\"location\":\"DE\",\"controls\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"}]}]},\"OldAsIsModel\":{\"type\":\"CloudEnvironment\",\"@id\":\"/\",\"tosca_nodes_root\":[{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.0\",\"name\":\"NUC 1 (Botcraft VM and IDS VM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.1\",\"name\":\"Dashboard Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"controlledBy\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"}]},{\"type\":\"Database\",\"@id\":\"//@tosca_nodes_root.2\",\"name\":\"Database\",\"id\":0,\"hostedOn\":{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},\"stores\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"}],\"encrypted\":false},{\"type\":\"DBMS\",\"@id\":\"//@tosca_nodes_root.3\",\"name\":\"IDS Data Lake\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"hosts\":[{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}]},{\"type\":\"DataSubject\",\"@id\":\"//@tosca_nodes_root.4\",\"name\":\"Person\",\"id\":0,\"trust\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"location\":\"DE\",\"owns\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.5\",\"name\":\"Robot MES\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.6\",\"name\":\"Kafka Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.7\",\"name\":\"Scene Detection\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.8\",\"name\":\"Data Flow (Scene Detection - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"connectionType\":\"Local\"},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.9\",\"name\":\"ABB Robot\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.10\",\"name\":\"IP Camera\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"StoredDataSet\",\"@id\":\"//@tosca_nodes_root.11\",\"name\":\"Stored Data Set\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"storedIn\":{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.12\",\"name\":\"Scene Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.13\",\"name\":\"NUC 2 (FogProtectVM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.14\",\"name\":\"Google ML Board-1\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.15\",\"name\":\"Robot Monitor Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.16\",\"name\":\"Data Flow (Dashboard Server - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.17\",\"name\":\"Data Flow (Robot MES - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.18\",\"name\":\"Robot Control\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.19\",\"name\":\"Data Flow (Robot Control - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.24\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.20\",\"name\":\"Data Flow (Robot Monitor - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.27\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.21\",\"name\":\"Data Flow (Camera Streamer - Scene Detection)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.22\",\"name\":\"Camera Streamer\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.23\",\"name\":\"Camera Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.24\",\"name\":\"Robot Control Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.25\",\"name\":\"Robot Monitor\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.26\",\"name\":\"Order\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.27\",\"name\":\"Robot Monitor Data Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.28\",\"name\":\"Data Flow (Dashboard Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.29\",\"name\":\"Data Flow (Kafka Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.30\",\"name\":\"Security Flag\",\"id\":0,\"partOf\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"PrivateSpace\",\"@id\":\"//@tosca_nodes_root.31\",\"name\":\"FiaB Shipping Container\",\"id\":0,\"consistsOf\":[{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"}],\"trustworthy\":\"LOW\"},{\"type\":\"DataController\",\"@id\":\"//@tosca_nodes_root.32\",\"name\":\"FiaB Worker\",\"id\":0,\"location\":\"DE\",\"controls\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"}]}]},\"ChangesMadeToAsIsModel\":[{\"ObjectToIdentify\":{\"name\":\"Data Flow (Dashboard Server - Kafka Server)\",\"type\":\"fogprotect.adaptation.ComputingContinuumModel.DataFlow\",\"atid\":\"//@tosca_nodes_root.16\"},\"Changes\":[{\"ChangeType\":\"CHANGE\",\"AttributeChanged\":\"disab\",\"AttributeType\":\"EBoolean\",\"AttributeOldValue\":\"false\",\"AttributeNewValue\":\"true\"}]},{\"ObjectToIdentify\":{\"name\":\"Data Flow (Dashboard Server - IDS Data Lake)\",\"type\":\"fogprotect.adaptation.ComputingContinuumModel.DataFlow\",\"atid\":\"//@tosca_nodes_root.28\"},\"Changes\":[{\"ChangeType\":\"CHANGE\",\"AttributeChanged\":\"disab\",\"AttributeType\":\"EBoolean\",\"AttributeOldValue\":\"false\",\"AttributeNewValue\":\"true\"}]}],\"Risks\":[]},\"Adaptations\":[]}";
		producerClient.sendMessage("ModelChange4SIEA", jsonString);
		return new ResponseEntity<String>("Done", HttpStatus.OK);
	}

	@GetMapping(path = "sendStatusInformationToModelChange")
	public ResponseEntity<String> sendStatusInformationToModelChange() {
		String jsonString = "{\"AsIs\":{\"AsIsModel\":{\"type\":\"CloudEnvironment\",\"@id\":\"//\",\"tosca_nodes_root\":[{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.0\",\"name\":\"NUC 1 (Botcraft VM and IDS VM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.1\",\"name\":\"Dashboard Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"controlledBy\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"}]},{\"type\":\"Database\",\"@id\":\"//@tosca_nodes_root.2\",\"name\":\"Database\",\"id\":0,\"hostedOn\":{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},\"stores\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"}],\"encrypted\":false},{\"type\":\"DBMS\",\"@id\":\"//@tosca_nodes_root.3\",\"name\":\"IDS Data Lake\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"hosts\":[{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}]},{\"type\":\"DataSubject\",\"@id\":\"//@tosca_nodes_root.4\",\"name\":\"Person\",\"id\":0,\"trust\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"location\":\"DE\",\"owns\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.5\",\"name\":\"Robot MES\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.6\",\"name\":\"Kafka Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.7\",\"name\":\"Scene Detection\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.8\",\"name\":\"Data Flow (Scene Detection - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"connectionType\":\"Local\"},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.9\",\"name\":\"ABB Robot\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.10\",\"name\":\"IP Camera\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"StoredDataSet\",\"@id\":\"//@tosca_nodes_root.11\",\"name\":\"Stored Data Set\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"storedIn\":{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.12\",\"name\":\"Scene Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.13\",\"name\":\"NUC 2 (FogProtectVM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.14\",\"name\":\"Google ML Board-1\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.15\",\"name\":\"Robot Monitor Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.16\",\"name\":\"Data Flow (Dashboard Server - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":true,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.17\",\"name\":\"Data Flow (Robot MES - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.18\",\"name\":\"Robot Control\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.19\",\"name\":\"Data Flow (Robot Control - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.24\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.20\",\"name\":\"Data Flow (Robot Monitor - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.27\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.21\",\"name\":\"Data Flow (Camera Streamer - Scene Detection)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.22\",\"name\":\"Camera Streamer\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.23\",\"name\":\"Camera Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.24\",\"name\":\"Robot Control Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.25\",\"name\":\"Robot Monitor\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.26\",\"name\":\"Order\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.27\",\"name\":\"Robot Monitor Data Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.28\",\"name\":\"Data Flow (Dashboard Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":true,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.29\",\"name\":\"Data Flow (Kafka Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.30\",\"name\":\"Security Flag\",\"id\":0,\"partOf\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"PrivateSpace\",\"@id\":\"//@tosca_nodes_root.31\",\"name\":\"FiaB Shipping Container\",\"id\":0,\"consistsOf\":[{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"}],\"trustworthy\":\"LOW\"},{\"type\":\"DataController\",\"@id\":\"//@tosca_nodes_root.32\",\"name\":\"FiaB Worker\",\"id\":0,\"location\":\"DE\",\"controls\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"}]}]},\"OldAsIsModel\":{\"type\":\"CloudEnvironment\",\"@id\":\"/\",\"tosca_nodes_root\":[{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.0\",\"name\":\"NUC 1 (Botcraft VM and IDS VM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.1\",\"name\":\"Dashboard Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"controlledBy\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"}]},{\"type\":\"Database\",\"@id\":\"//@tosca_nodes_root.2\",\"name\":\"Database\",\"id\":0,\"hostedOn\":{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},\"stores\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"}],\"encrypted\":false},{\"type\":\"DBMS\",\"@id\":\"//@tosca_nodes_root.3\",\"name\":\"IDS Data Lake\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"hosts\":[{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}]},{\"type\":\"DataSubject\",\"@id\":\"//@tosca_nodes_root.4\",\"name\":\"Person\",\"id\":0,\"trust\":[{\"type\":\"DataController\",\"referencedObjectID\":\"//@tosca_nodes_root.32\"}],\"location\":\"DE\",\"owns\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.5\",\"name\":\"Robot MES\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.6\",\"name\":\"Kafka Server\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}]},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.7\",\"name\":\"Scene Detection\",\"id\":0,\"hostedOn\":{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.8\",\"name\":\"Data Flow (Scene Detection - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"connectionType\":\"Local\"},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.9\",\"name\":\"ABB Robot\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"IoTDevice\",\"@id\":\"//@tosca_nodes_root.10\",\"name\":\"IP Camera\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"StoredDataSet\",\"@id\":\"//@tosca_nodes_root.11\",\"name\":\"Stored Data Set\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"storedIn\":{\"type\":\"Database\",\"referencedObjectID\":\"//@tosca_nodes_root.2\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.12\",\"name\":\"Scene Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.8\"},{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.28\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.13\",\"name\":\"NUC 2 (FogProtectVM)\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"FogCompute\",\"@id\":\"//@tosca_nodes_root.14\",\"name\":\"Google ML Board-1\",\"id\":0,\"hosts\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"}],\"jurisdiction\":\"DE\",\"usageCostPerDay\":0.0,\"capacity\":0,\"transferCostPerGB\":0.0,\"costIncurred\":false,\"compromised\":false,\"partOf\":{\"type\":\"PrivateSpace\",\"referencedObjectID\":\"//@tosca_nodes_root.31\"}},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.15\",\"name\":\"Robot Monitor Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.16\",\"name\":\"Data Flow (Dashboard Server - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.17\",\"name\":\"Data Flow (Robot MES - Kafka Server)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.15\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.26\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.18\",\"name\":\"Robot Control\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}]},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.19\",\"name\":\"Data Flow (Robot Control - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.24\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.18\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.20\",\"name\":\"Data Flow (Robot Monitor - Robot MES)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.27\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.5\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.25\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.21\",\"name\":\"Data Flow (Camera Streamer - Scene Detection)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.23\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.7\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.22\"}],\"connectionType\":\"Local\"},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.22\",\"name\":\"Camera Streamer\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.23\",\"name\":\"Camera Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.21\"}],\"sensitive\":false,\"encrypted\":false,\"belongsTo\":{\"type\":\"DataSubject\",\"referencedObjectID\":\"//@tosca_nodes_root.4\"},\"personal\":true},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.24\",\"name\":\"Robot Control Data\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.19\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"SoftwareComponent\",\"@id\":\"//@tosca_nodes_root.25\",\"name\":\"Robot Monitor\",\"id\":0,\"hostedOn\":{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},\"neededCapacity\":0,\"hasToBeDeployedOnFogNode\":false,\"transferBy\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}]},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.26\",\"name\":\"Order\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.17\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.27\",\"name\":\"Robot Monitor Data Stream\",\"id\":0,\"partOf\":[{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.20\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.28\",\"name\":\"Data Flow (Dashboard Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"},{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"}],\"connectionType\":\"Local\"},{\"type\":\"DataFlow\",\"@id\":\"//@tosca_nodes_root.29\",\"name\":\"Data Flow (Kafka Server - IDS Data Lake)\",\"id\":0,\"consistsOf\":[{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.12\"},{\"type\":\"Record\",\"referencedObjectID\":\"//@tosca_nodes_root.30\"}],\"disab\":false,\"amountOfDataInGB\":0.0,\"transfersTo\":[{\"type\":\"DBMS\",\"referencedObjectID\":\"//@tosca_nodes_root.3\"},{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.6\"}],\"connectionType\":\"Local\"},{\"type\":\"Record\",\"@id\":\"//@tosca_nodes_root.30\",\"name\":\"Security Flag\",\"id\":0,\"partOf\":[{\"type\":\"StoredDataSet\",\"referencedObjectID\":\"//@tosca_nodes_root.11\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.16\"},{\"type\":\"DataFlow\",\"referencedObjectID\":\"//@tosca_nodes_root.29\"}],\"sensitive\":false,\"encrypted\":false,\"personal\":false},{\"type\":\"PrivateSpace\",\"@id\":\"//@tosca_nodes_root.31\",\"name\":\"FiaB Shipping Container\",\"id\":0,\"consistsOf\":[{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.0\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.9\"},{\"type\":\"IoTDevice\",\"referencedObjectID\":\"//@tosca_nodes_root.10\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.13\"},{\"type\":\"FogCompute\",\"referencedObjectID\":\"//@tosca_nodes_root.14\"}],\"trustworthy\":\"LOW\"},{\"type\":\"DataController\",\"@id\":\"//@tosca_nodes_root.32\",\"name\":\"FiaB Worker\",\"id\":0,\"location\":\"DE\",\"controls\":[{\"type\":\"SoftwareComponent\",\"referencedObjectID\":\"//@tosca_nodes_root.1\"}]}]},\"ChangesMadeToAsIsModel\":[{\"ObjectToIdentify\":{\"name\":\"Data Flow (Dashboard Server - Kafka Server)\",\"type\":\"fogprotect.adaptation.ComputingContinuumModel.DataFlow\",\"atid\":\"//@tosca_nodes_root.16\"},\"Changes\":[{\"ChangeType\":\"CHANGE\",\"AttributeChanged\":\"disab\",\"AttributeType\":\"EBoolean\",\"AttributeOldValue\":\"false\",\"AttributeNewValue\":\"true\"}]},{\"ObjectToIdentify\":{\"name\":\"Data Flow (Dashboard Server - IDS Data Lake)\",\"type\":\"fogprotect.adaptation.ComputingContinuumModel.DataFlow\",\"atid\":\"//@tosca_nodes_root.28\"},\"Changes\":[{\"ChangeType\":\"CHANGE\",\"AttributeChanged\":\"disab\",\"AttributeType\":\"EBoolean\",\"AttributeOldValue\":\"false\",\"AttributeNewValue\":\"true\"}]}],\"Risks\":[]},\"Adaptations\":[]}";
		producerClient.sendMessage("ModelChange", jsonString);
		return new ResponseEntity<String>("Done", HttpStatus.OK);
	}

	@GetMapping(path = "sendAdaptationNotPossiblenToModelChange")
	public ResponseEntity<String> sendAdaptationNotPossibleToModelChange() {
		String jsonString = "AdaptationNotPossible";
		producerClient.sendMessage("ModelChange", jsonString);
		return new ResponseEntity<String>("Done", HttpStatus.OK);
	}
	
	@RequestMapping(path = "/test", method = RequestMethod.POST, consumes = "*/*; charset=UTF-8")
	@ResponseBody
	public void listenToContainerStatus(@RequestBody(required = true) String msg) {
		log.info("FiaBContainerStatus: " + msg, className);
		/*
		 * Possible contents: b'AdaptationRequired-DoorHasOpened'
		 * b'AdaptationRequired-DoorHasClosed'
		 * b'AdaptationRequired-ClearanceGiven'
		 */

		if (msg.equals("AdaptationRequired-DoorHasOpened")) {
			JsonObject head = new JsonObject();
			head.addProperty("RequestType", "changeAttribute");
			head.addProperty("@id", "//@tosca_nodes_root.31");
			head.addProperty("attribute", "trustworthy");
			head.addProperty("newValue", "LOW");
			head.addProperty("attributeType", "Trustworthy");
			monitoringController.monitoringEvent(head.toString());
		}
		if (msg.equals("AdaptationRequired-DoorHasClosed")) {
			JsonObject head = new JsonObject();
			head.addProperty("RequestType", "changeAttribute");
			head.addProperty("@id", "//@tosca_nodes_root.31");
			head.addProperty("attribute", "trustworthy");
			head.addProperty("newValue", "MEDIUM");
			head.addProperty("attributeType", "Trustworthy");
			monitoringController.monitoringEvent(head.toString());
		}
		if (msg.equals("AdaptationRequired-ClearanceGiven")) {
			JsonObject head = new JsonObject();
			head.addProperty("RequestType", "changeAttribute");
			head.addProperty("@id", "//@tosca_nodes_root.31");
			head.addProperty("attribute", "trustworthy");
			head.addProperty("newValue", "HIGH");
			head.addProperty("attributeType", "Trustworthy");
			monitoringController.monitoringEvent(head.toString());
		}
	}

}
